import React from 'react';
import ReactDOM from 'react-dom';
import $ from 'jquery';

var ReadHtml = React.createClass({

  _isPlaying: false,
  startTime: null,
  currWord: -1,
  ReadHtmlDOM: null,

  getDefaultProps() {
    return {
      transcript: "",
      audioURL: "",
      autoplay: false,
      clickplay: true,
      onEnded: null,
      highlight: false,
      inlineHighlightStyle: ""      
    };
  },

  getInitialState() {
  	var transcript = this.props.transcript || "";
    return { 
    	transcript: transcript,
      	currWord: -1
    };
  },

  play() {
    this._isPlaying = true;
    this.refs.ReadHtmlAudio.currentTime = 0;
    this.refs.ReadHtmlAudio.play();

    this.setState( { currWord: -1 } );
    this.currWord = -1;

    this.startTime = new Date();
    this._wordStarted();
  },

  stop() {
    if ( this.refs.ReadHtmlAudio && typeof this.refs.ReadHtmlAudio.stop == "function" ) {
      this.refs.ReadHtmlAudio.stop();
    }
    this.currWord = -1;
    this.setState( { currWord: -1 } );    
    this._isPlaying = false;
  },

  replay() {
    if ( !this._isPlaying && (this.props.clickplay == true) ) {
      this.play();
    }
  },

  _wordStarted() {  	
    if ( !this._isPlaying ) {
      return;
    }

    this.currWord++;
    this.setState( function( prevState ) { return { currWord: prevState.currWord + 1 } } );
    this._waitForWordToEnd();
  },

  _waitForWordToEnd() {
    if ( !this._isPlaying ) {
      return;
    }
    if ( this.currWord == -1 || this.currWord > $("timing").length ) {
      this.stop();
      return;
    }
   
    if ( $("timing").length > 0 ) {
      var currTime = new Date();
      var elapsed = currTime - this.startTime;
      
      var waitTime = $("timing:nth-of-type("+this.currWord+")").attr("end") - elapsed;
      
      if ( waitTime > 0 ) {
         var $this = this;
         setTimeout( function() { $this._waitForWordToEnd(); }, waitTime );
      } else {
         this._wordEnded();
      }
    }
  },

  _wordEnded() {
    if ( !this._isPlaying ) {
      return;
    }

    if ( this.currWord < $("timing").length ) {
      this._waitForWordToStart();
    } else {
      this.stop();
      if ( this.props.onEnded && typeof this.props.onEnded == "function" ) {
        this.props.onEnded();
      }
    }
  },

  _waitForWordToStart() {
    if ( !this._isPlaying ) {
      return;
    }
    if ( this.currWord == -1 || this.currWord >= $("timing").length ) {
      this.stop();     	
      return;
    }
   
    if ( $("timing").length > 0 ) {
      var currTime = new Date();
      var elapsed = currTime - this.startTime;
      var waitTime = $("timing:nth-of-type("+this.currWord+")").attr("start") - elapsed;
      
      if ( waitTime > 0 ) {
         var $this = this;
         setTimeout( function() { $this._waitForWordToStart(); }, waitTime );
      } else {
         this._wordStarted();
      }
    }
  },

  audioReady() {
    if (( this.props.autoplay ) && ( !this._isPlaying )) {
      this.play();
    }
  },

  componentDidMount() {
  	this.ReadHtmlDOM = $(ReactDOM.findDOMNode(this.refs.ReadHtml));
    if ( this.props.autoplay && this.refs.ReadHtmlAudio.readyState >= 4 ) {
      this.play();
    }
  },

  componentDidUpdate( prevProps ) {
    if ( JSON.stringify( prevProps ) != JSON.stringify( this.props ) ) {
      if ( this.props.autoplay ) {
        this.play();
      }
    } 
  },

  componentWillUnmount() {
    this.stop();
  },

  componentWillReceiveProps() {
  },

  render() {
   //Reset old timing
   $("timing").attr('style','');
   $("timing").removeClass("highlighted");
   if(this._isPlaying) {	
   		$($("timing")[this.currWord-1]).attr('style', "background-color: #FFFF00");
    	if(this.props.highlight)
    		$(this.ReadHtmlDOM.find("timing")[this.currWord-1]).addClass("highlighted");
    }
      	    
   
    var audio = "";
    if ( this.props.audioURL ) {
      audio = ( <audio preload="auto" ref="ReadHtmlAudio" className="ReadHtmlAudio" src={this.props.audioURL} onCanPlayThrough={this.audioReady}></audio> );
    }
    return (
      <div ref="ReadHtml" className="ReadHtmlContainer" onClick={this.replay}>
        <span className="ReadHtml">
          <p dangerouslySetInnerHTML={{__html: this.props.transcript}} />
        </span>
        {audio}
      </div>
    );
  }
});

export default ReadHtml;
